#include "main.h"

int main(int argc, char** argv){

	
	//Variables temporales
	char *file_name;
	file_name=new char[30];
	char *tempoString;
	tempoString=new char[32];
	int inicio,fin;

	//Empieza el programa
	printf("MODEL CONVERSOR V.1.0 BY ANKH\n\n");

	//Le pongo el directorio de trabajo
	printf("WORKING DIRECTORY PATH: ");
	scanf("%s",file_name);
	chdir(file_name);

	printf("ORIGINAL FILE NAME (without numbers):");
	scanf("%s",originalFileName);

	//Pido el nombre q tendra el personaje
	printf("SAVE AS: ");
	scanf("%s",file_name);

	printf("INSERT RATIO: ");
	scanf("%f",&RATIO);

	printf("INSERT DEFAULT SPEED IN TICKS: ");
	scanf("%d",&speed);

	printf("INSERT NUMBER OF FRAMES: ");
	scanf("%d",&frames);

	printf("INSERT NUMBER OF ANIMATIONS: ");
	scanf("%d",&animations);

	//Le aado la coletilla .car y intento crear el fichero
	sprintf(tempoString,"%s.mdh",file_name);
	DESTINO=fopen(tempoString,"w");
	if (!DESTINO) {
		printf("Couldn't create caracter file\n");
		return 1;
	}

	READ=fopen("frames.txt","r");
	if (!READ)  {
		printf("Couldn't find frames file\n");
		return 1;
	}

	bool firstTime=true;

	while (!feof(READ)){
		fscanf(READ,"%d %d %d", &inicio, &fin, &dinamico);

		if(firstTime){
			if (!inizializate(inicio)){
				printf("ERROR INIZIALITATING LEGS\n");
				return 0;
			}
			firstTime=false;
		}
		if(!addAnimation(inicio,fin,dinamico)) {
			printf("ERROR CREATING MODEL\n");
			return 0;
		}
	}
		

	fclose (READ);
	
	fclose (DESTINO);
	//Solucion a un error de memoria q da al hacer el return

	printf("\nMODEL CREATED\n");
	exit (0);
	return 0;
}

bool inizializate(int begin){

	//Variables temporales
	char *tempo,*textura;
	tempo=new char[30];
	textura=new char[10];
	int num_material=0,j=0,k=0;
	int faces=0,vertex=0;
	float tempoFloat=0;
	int tempoInt=0;


	if (begin >=0 && begin <10) sprintf(tempo,"%s00%d.ase",originalFileName,begin);
	else if (begin >=10 && begin <100) sprintf(tempo,"%s0%d.ase",originalFileName,begin);
	else if (begin >=100 && begin <1000) sprintf(tempo,"%s%d.ase",originalFileName,begin);
	else return false;
	
	ORIGEN=fopen (tempo,"r");
	if (!ORIGEN) return false;


	//Miro que material utiliza el modelo
	while (!feof(ORIGEN)){
		fscanf(ORIGEN,"%s",tempo);
		if (!strcmp(tempo,"*MATERIAL_REF")) fscanf(ORIGEN,"%d",&num_material);
	}

	rewind (ORIGEN);
			
	//Busco el nombre de la textura del modelo y solo cojo el nombre del archivo
	//(sin la ruta)
	while (!feof(ORIGEN) && num_material>=0){
		fscanf(ORIGEN,"%s",tempo);
		if (!strcmp(tempo,"*MATERIAL")){
			if (num_material==0){
				do{
					fscanf(ORIGEN,"%s",tempo);
				}while (strcmp(tempo,"*BITMAP") && !feof(ORIGEN));
				getFileName(ORIGEN,textura);
				
			}
			num_material--;
		}
	}

	rewind (ORIGEN);
	
	//Empiezo a escribir el fichero
	fprintf(DESTINO,"#MODEL CREATED BY ASE2MDH CONVERSOR - ANKH 2002\n");
	fprintf(DESTINO,"#\n");
	fprintf(DESTINO,"&NUM_FRAMES %d\n",frames);
	fprintf(DESTINO,"&NUM_ANIMATIONS %d\n",animations);
	fprintf(DESTINO,"&SPEED %d\n", speed);
	fprintf(DESTINO,"&TEXTURE %s\n",textura);

	while (!feof(ORIGEN)){
		fscanf(ORIGEN,"%s",tempo);

		//Busco la parte del ase correspondiente al modelo en si
		if (!strcmp(tempo,"*NODE_NAME")){
				//Busco el numero de vertices q tiene
				do{
					fscanf(ORIGEN,"%s",tempo);
				}while (strcmp(tempo,"*MESH_NUMVERTEX") && !feof(ORIGEN));
				fscanf(ORIGEN,"%d",&vertex);
				fprintf(DESTINO,"&VERTEX %d\n",vertex);

				//Busco el numero de caras q tiene
				do{
					fscanf(ORIGEN,"%s",tempo);
				}while (strcmp(tempo,"*MESH_NUMFACES") && !feof(ORIGEN));
				fscanf(ORIGEN,"%d",&faces);
				fprintf(DESTINO,"&FACES %d\n",faces);
				//Escribo todas las caras en el fichero
				for (j=0; j<faces;j++){
					do{
						fscanf(ORIGEN,"%s",tempo);
					}while(strcmp(tempo,"A:"));
					fscanf (ORIGEN,"%d",&tempoInt);
					fprintf(DESTINO,"%d ", tempoInt);

					do{
						fscanf(ORIGEN,"%s",tempo);
					}while(strcmp(tempo,"B:"));
					fscanf (ORIGEN,"%d",&tempoInt);
					fprintf(DESTINO,"%d ", tempoInt);

					do{
						fscanf(ORIGEN,"%s",tempo);
					}while(strcmp(tempo,"C:"));
					fscanf (ORIGEN,"%d",&tempoInt);
					fprintf(DESTINO,"%d\n", tempoInt);
				}

				//Busco el numero de vertices de textura q tiene
				do{
					fscanf(ORIGEN,"%s",tempo);
				}while (strcmp(tempo,"*MESH_NUMTVERTEX") && !feof(ORIGEN));
				fscanf(ORIGEN,"%d",&vertex);
				fprintf(DESTINO,"\n&MAP_PARTS %d\n", vertex);

				//Escribo todos los vertices de textura en el fichero
				for (j=0; j<vertex;j++){
					do{
						fscanf(ORIGEN,"%s",tempo);
					}while(strcmp(tempo,"*MESH_TVERT"));
					fscanf (ORIGEN,"%d",&tempoInt);
					fscanf (ORIGEN,"%f",&tempoFloat);
					fprintf(DESTINO,"%f ",tempoFloat);

					fscanf (ORIGEN,"%f",&tempoFloat);

					//Se ha de restar la y a 1 para q la lea bien opengl
					fprintf(DESTINO,"%f\n",1.0f-tempoFloat);
					
				}

				//Escribo el numero de caras de textura q tiene
				do{
					fscanf(ORIGEN,"%s",tempo);
				}while (strcmp(tempo,"*MESH_NUMTVFACES") && !feof(ORIGEN));
				fscanf(ORIGEN,"%d",&faces);
				fprintf(DESTINO,"\n&MAP_FACES %d\n", faces);

				//Escribo todas las caras de textura en el fichero
				for (j=0; j<faces;j++){
					do{
						fscanf(ORIGEN,"%s",tempo);
					}while(strcmp(tempo,"*MESH_TFACE"));
					fscanf (ORIGEN,"%d",&tempoInt);
					
					fscanf (ORIGEN,"%d",&tempoInt);
					fprintf(DESTINO,"%d ",tempoInt);
					
					fscanf (ORIGEN,"%d",&tempoInt);
					fprintf(DESTINO,"%d ",tempoInt);										

					fscanf (ORIGEN,"%d",&tempoInt);
					fprintf(DESTINO,"%d\n",tempoInt);	
				}

			}
		}

	

	//Cierro el fichero ase
	fclose (ORIGEN);
	return true;
}

bool addAnimation(int begin, int end, bool dinamico){

	//Variables temporales
	char *tempo;
	char *nombreArchivo;
	char *parte;
	tempo=new char[30];
	nombreArchivo=new char[30];
	parte=new char[6];
	int vertex;
	int cont;
	float x,y,z;

	//Bucle que pasa por todos los ficheros entre el begin y el end para cojer sus vertices
	for (cont=begin;cont<=end;cont++){
		printf("Loading %d\n",cont);

		//Abro el fichero correspondiente
		if (cont >=0 && cont <10) sprintf(nombreArchivo,"%s00%d.ase",originalFileName,cont);
		else if (cont >=10 && cont <100) sprintf(nombreArchivo,"%s0%d.ase",originalFileName,cont);
		else if (cont >=100 && cont <1000) sprintf(nombreArchivo,"%s%d.ase",originalFileName,cont);
		else return false;
		

		ORIGEN=fopen(nombreArchivo,"r");
		if (!ORIGEN) return false;

		
		//Ahora busco los vertices del frame
		while (!feof(ORIGEN)){
			fscanf(ORIGEN,"%s",tempo);
			if (!strcmp(tempo,"*NODE_NAME")){
					do{
						fscanf(ORIGEN,"%s",tempo);
					}while (strcmp(tempo,"*MESH_NUMVERTEX") && !feof(ORIGEN));
					fscanf(ORIGEN,"%d",&vertex);
					//Compruebo si es el primer frame de la animacion y si es dinamica o no
					if (cont==begin) {
						if (dinamico) fprintf(DESTINO,"\n*D\n");
						else fprintf(DESTINO,"\n*S\n");
					}
					else fprintf(DESTINO,"\n.\n");

					//Copio todos los vertices en el fichero
					for (register int i=0;i<vertex;i++){
						do{
							fscanf(ORIGEN,"%s",tempo);
						}while (strcmp(tempo,"*MESH_VERTEX") && !feof(ORIGEN));
						fscanf (ORIGEN,"%s");
						fscanf (ORIGEN,"%f",&x);
						fscanf (ORIGEN,"%f",&z);
						fscanf (ORIGEN,"%f",&y);

						//Le resto el LOWER_UNION para colocar el objeto en el centro de
						//coordenadas


						x*=-RATIO;
						y*=RATIO;
						z*=RATIO;

						fprintf(DESTINO,"%f %f %f\n",x,y,z);
					}
			}
		}
		
		//Cierro el fichero
		fclose(ORIGEN);
	}



	return true;
	

}
