#!/bin/sh
# A simple build tools :)

if [ "$1" = "" ]; then
	echo "Usage '$0' [target]"
	exit 1;
fi

if [ "${MAKE}" = "" ]; then
	MAKE="make";
fi

for A in * ; do
 if [ ! "$A" = "CVS" ]; then
 if [ -d "$A" ]; then
   printf "\e[32m** Using target $1 on $A...\e[0m\n"
   cd $A
   ${MAKE} $1
   if [ ! "$?" = "0" ]; then
   	printf "\e[34m### ERROR BUILDING '$A' ###\e[0m\n"
   	exit 1;
   fi
   cd ..
 fi
 fi
done

