#include <string.h>
#include <stdio.h>

#define MDH_MAGIC "MDH\0"

#define MDH_MAJOR_VERSION 0
#define MDH_MINOR_VERSION 1

enum 
{
	// header
	MDH_NUMFRAMES,  // char
	MDH_NUMANIMATIONS,
	MDH_SPEED,
	MDH_TEXTURE, // string
	// raw data
	MDH_VERTEX,
	MDH_FACES,
	MDH_MAPPARTS,
	MDH_MAPFACES,
	// animation 
	MDH_DINAMIC,
	MDH_STATIC,
	MDH_NEXTFRAME
};
