#include <string.h>
#include <stdio.h>

#define MPH_MAGIC "MPH\0"
#define MPH_MAJOR_VERSION 0
#define MPH_MINOR_VERSION 1

enum 
{
	// header
	MPH_NUMROOMS,
	MPH_NUMITEMS,
	MPH_NUMWEAPONS,
	MPH_MODITEMS,
	MPH_TEXTURES,
 
	MPH_TEXTURE, // %d %s
	MPH_NUMSTARTS, // %d
	MPH_START, // %d\n%f %f %f

	MPH_ROOM, // %d
	MPH_PORTAL,
	MPH_NUMPORTALS, // %d
	MPH_NUMVERTEX, // %d %d*(%f %f %f)

	MPH_NUMFACES, // %d %d*(%d %d %d %d)
	MPH_NUMTEXTVERTEX, // %d\n%d*(%f %f)
	MPH_NUMTEXTFACES, // %d\n%d*(%d %d %d)
	MPH_ELEMENT, // %s [ PORTAL %d \n 4x(%f %f %f)| HAB ] 

	MPH_RATIO, // %f 0.001
	MPH_PVS,
	MPH_HAB,
	MPH_AUDIO
};
