#ifndef _FIGURE_H_
#define _FIGURE_H_

#include <stdio.h>
#include "OpenGLH.h"

//Esta es la clase que guarda cada posicion de la animacion de un personaje (un frame
//de una animacin.

//Clase que almacena los diferentes frames de la animacion
class Figure
{
private:
	float *vertex;	//Array con la posicion de cada vertice (x,y,z);
	unsigned int numFaces;   //Numero de caras
	
public:
	//Constructor de la clase al cual recibe el numero de caras que el objeto tiene
	Figure(unsigned int num_faces_old);

	//Constructor de copia de la clase
	Figure(Figure &Figure_copia);

	//Destructor
	~Figure();

	//Crea una estructura de floats con la posicion de los distintos vertices 
	void addVertex(float *vertex_old);

	//Funcion que devuelve el array de vertices del objeto
	float *getVertex();
};
#endif

