#ifndef _INTERFACE_H_
#define _INTERFACE_H_

#if WIN32
#include <windows.h>
#endif
#include "Dirs.h"

class Interface {
	// Atributes of the player
private:
	int health;
	int kevlar;
	int helmet;
	int strength;
	int defense;
	int aim;
	int velocity;
	int munition;

	int font_tid;
	unsigned int mira_tid;
	int thud_tid;

	void putstring(char *s,float x,float y,float r,float g,float b,double size, int type);

public:
	Interface(char* hud="hud.png", char* fontBig="font_big.png", char* mira="mira.png");
	~Interface();
	void paint();
	void setHealth(int value) { health = value;};
	void setKevlar(int value) { kevlar = value;};
	void setHelmet(int value) { helmet = value;};
	void setStrength(int value) { strength = value;};
	void setDefense(int value) { defense = value;};
	void setAim(int value) { aim = value;};
	void setVelocity(int value) { velocity = value;};
	void setMunition(int value) { munition = value;};
};

#endif



