#include "Item.h"

Item::Item(char* tipo_old):Properties(tipo_old)
{
	tipo=0;
	setTipo(tipo_old);

	//Activamos la rotacion por defecto de los Items
	setRotationAngle(ROTATE_ANGLE_ITEMS);
	activateRotation(ROTATE_SPEED_ITEMS);
}

Item::~Item()
{
	free(tipo);
}

void Item::setTipo(char *tipo_old)
{
	char tempo[1024];
	sprintf(tempo,"%s.mdh",tipo_old);
	tipo=strdup(tipo_old);
	printf("  ITEM %s CREATED\n",tipo_old);
}

char *Item::getTipo()
{
	return tipo;
}

void Item::setId(int id_old)
{
	id=id_old;
}

int Item::getId()
{
	return id;
}

