#include <SDL/SDL.h>
#include "Dirs.h"
#include "OpenGLH.h"
#include "TGAloader.h"
#include "Menu.h"
#include <stdlib.h>

enum {
	MENU_CLIENT=0,
	MENU_SERVER,
	MENU_OFFLINE,
	MENU_OPTIONS,
	MENU_EXIT,
	MENU_LAST
}; 

class MainMenu
{
private:
	int option;
	bool keypressed;
	bool esc;
	unsigned int mouse;
	float cursorX,cursorY;
	unsigned int background;
	Menu* m;

	void setOption(int);
public:
	MainMenu();
	~MainMenu();
	void drawScene();
	void getKeys();
	bool isFinished();
	int getOption();
};
