#include "Menu.h"

Menu::Menu()
{
	n = 0;
	items = NULL;
}

Menu::~Menu()
{
	free(items);
}

void Menu::addButton(float x1, float y1, float x2, float y2)
{
	n++;
	if (items == NULL)
		items=(char *)malloc(sizeof(float)*4);
	else
		items=(char *)realloc(items,sizeof(float)*4*n);
	n--;
	memcpy(items+sizeof(float)*4*n+sizeof(float)*0, &x1, sizeof(float));
	memcpy(items+sizeof(float)*4*n+sizeof(float)*1, &y1, sizeof(float));
	memcpy(items+sizeof(float)*4*n+sizeof(float)*2, &x2, sizeof(float));
	memcpy(items+sizeof(float)*4*n+sizeof(float)*3, &y2, sizeof(float));
	n++;
}

int Menu::isOverItem(int _x, int _y)
{
	float x=(float)_x/WIDTH;
	float y=(float)_y/HEIGHT;

//printf("%f %f\n",x,y);

	float x1,y1,x2,y2;
	for (int i=0;i<n;i++)
	{
		memcpy(&x1,items+sizeof(float)*4*i+sizeof(float)*0,sizeof(float));
		memcpy(&y1,items+sizeof(float)*4*i+sizeof(float)*1,sizeof(float));
		memcpy(&x2,items+sizeof(float)*4*i+sizeof(float)*2,sizeof(float));
		memcpy(&y2,items+sizeof(float)*4*i+sizeof(float)*3,sizeof(float));
//printf("%f %f %f %f\n",x1,y1,x2,y2);
		if (	( x > x1 && x < x2 ) && 
			( y > y1 && y < y2 )  )
		{
			return i;
		}
	}

	return -1;
}

