#ifndef _FUENTES_STR          
#define _FUENTES_STR

#include <string.h>
#include <stdarg.h>
#include "OpenGLH.h"
#include "TGAloader.h"
#include "external.h"


class Text2D
{
private:
	unsigned int mapabits;

public:

	Text2D();
	Text2D(char *file);
	~Text2D();

	/*! tam_base es el tamao base para esa fuente. Cuando se
	utilice la funcin print, el tamao que se especifique ah
	ser en funcin de como se inicializ 
	espacio_base es el espacio entre letras de cada fuente,
	es bastante dependiente del tipo de fuente */

	bool loadFont(char *file);

	/*! Especificamos el tipo de fuente (previamente creado), su
	posisicin (-1,-1 a 1,1), el tamao y el texto. Se pueden 
	utilizar cadenas las cadenas de formato como printf(etc) */								

	void print(char *text,float x,float y,float size);
	void print(char *text,float x,float y,float r,float g,float b,float size);
	void translate(int num, char* palabras);
	char translate(char ch);

	char *getName();
	unsigned int getMapabits()  { return mapabits; };
};					

#endif 

