#include "Weapon.h"

Weapon::Weapon(char *file){

	char buf[100];
	FILE *fd;

	chdir(getDirs(file));
	fd=fopen (file,"r");
	
	if (!fd)
	{
		printf(" ###### Error loading Weapon %s ######\n",file );
		killProgram(0);
	}

	damage=0;
	delay=0;
	maxAmmo=0;
	delay=0;

	do{
		buf[0]=0;
		fscanf(fd,"%s",buf);
		if (!strcmp(buf,"MODEL1")){
			fscanf(fd,"%s",buf);
			model1=new Properties(buf);
		}
		else if (!strcmp(buf,"MODEL3")){
			fscanf(fd,"%s",buf);
			model3=new Properties(buf);
		}
		else if (!strcmp(buf,"DAMAGE")){
			fscanf(fd,"%d",&damage);
		}
		else if (!strcmp(buf,"DELAY")){
			fscanf(fd,"%d",&delay);
		}
		else if (!strcmp(buf,"MAXAMMO")){
			fscanf(fd,"%d",&maxAmmo);
		}
		else if (!strcmp(buf,"TYPE")){
			fscanf(fd,"%d",&type);
		}

	} while (!feof(fd));

	fclose(fd);
}

int Weapon::getMaxAmmo(){
	return maxAmmo;
}

int Weapon::getDamage(){
	return damage;
}

int Weapon::getDelay(){
	return delay;
}
Properties *Weapon::getFirstView(){
	return model1;
}

Properties *Weapon::getThirdView(){
	return model3;
}


Weapon::Weapon(const Weapon &weapon_){
	model1=new Properties(*weapon_.model1);
	model3=new Properties(*weapon_.model3);
	maxAmmo=weapon_.maxAmmo;
	damage=weapon_.damage;
	delay=weapon_.delay;

}

void Weapon::update(){
	model1->update();
	model3->update();
}

