#ifndef _INCLUDE_MAIN_H_
#define _INCLUDE_MAIN_H_

#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Box.H>
#include <FL/Fl_Button.H>
#include <FL/Fl_Progress.H>
#include <FL/Fl_Help_View.H>
#include <FL/Fl_Input.H>
#include <FL/Fl_PNG_Image.H>
#include <FL/Fl_Image.H>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "ScriptH.h"
#include "Error.h"

#ifdef WIN32
#include <windows.h>
#define sleep(x) Sleep(x*1000)
#else
#include <unistd.h>
#endif

//===========================================

#define DEFAULT_SCRIPT "config.ins"

extern Fl_Progress *p;
extern ScriptH *scr;

#endif
