#include "../common/platform.h"
#include "../common/version.h"

#ifndef _INCLUDE_MAIN_H_
#define _INCLUDE_MAIN_H_

#if WINDOWS
	// Cal linkar wsock32.lib
	#include <windows.h>
	#include <winsock.h>
	#include <malloc.h>
	#include <direct.h>
	#define mkdir(str,str2) mkdir(str)
#else
	#include <netinet/in.h>
	#include <unistd.h>
	#include <sys/socket.h>
	#include <netdb.h>
	#include <sys/stat.h>
	#include <sys/types.h>
#endif
	#include <stdio.h>
	#include <stdlib.h>
	#include <string.h>
	#include <pthread.h>
	#include <sys/types.h>
	#include "../common/packet.h"
	#include "../common/dirs.h"
	#include "packets.h"

// global variables
	char key[4]; // crc key
	int s; // socket
	unsigned int bsize=10240; // Buffer size

// global functions
	int main(int argc,char **argv);
	void *console(void *arg);
#endif
