#include "packets.h"

void cli_reciveOkOk()
{
	printf("OkOk recived . reply your okok =)\n");
}

void cli_packetErr()
{
	char b[1];
	char *str;
	
	recv(s,b,1,0);
	str=(char *)malloc(b[0]+1);
	recv(s,str,b[0],0);
	str[b[0]]=0;
	printf("Packet error, server says: \"%s\".\n",str);
	free(str);
	exit(1);
}

void cli_reciveItem()
{
	char b[2];
	recv(s,b,2,0);
	printf("ITEM %d GIVE %d\n",b[0],b[1]);
}

void cli_checkFile()
{
	char *b,
	     *str,
	     *crc;
	unsigned int i;
	FILE *fd;
		
	b=(char *)malloc(5);
	str=(char *)malloc(300);

	recv(s,b,1,0);
	recv(s,str,b[0],0);
	str[b[0]]=0;
	printf("   - Checking file %s...",str);
	chdir (makeDirs(str));
	fd=fopen(str,"r"); 
	if (!fd)
	{
		printf("not found\n");
		b[0]=PACKET_CRCF; // reply my crc
		memset(b+1,0,4); // null crc body
		send(s,b,5,0); // send my crc.
	} else {
		fseek(fd,0L,SEEK_END);
		i=ftell(fd);
		if (!i) i=20;
		fseek(fd,0L,SEEK_SET);
		str=(char*)realloc(str,i); // resize baffah!
		if (!str)
		{
			printf("Error reallocating %d :/\n",i);
			exit(1);
		}
		fread(str,i,1,fd);
		
		i = htonl(crc32(str,i)); // i=crc result.
		crc=(char *)&i;
		printf("found as crc [%2x:%2x:%2x:%2x]\n",
			(unsigned char)crc[0],
			(unsigned char)crc[1],
			(unsigned char)crc[2],
			(unsigned char)crc[3]);
		// Change for better code.
		str[0]=PACKET_CRCF;
		/*
		memcpy(str+1,crc,4);
		send(s,str,5,0);
		*/
		send(s,str,1,0); // send packet type.
		send(s,crc,4,0); // Send crc
	}
	chdir("../..");
	free (str);
	free(b);
}

void cli_saveFile()
{
	char *b;
	unsigned int *i;
	unsigned long I,n,m,j;
	FILE *fd;

	b=(char *)malloc(bsize);
	if (!b)
	{
		printf("Error on malloc\n");
		exit(1);
	}
	recv(s,b,1,0);
	j=(unsigned int)b[0];
	  recv(s,b,j,0);
	  b[j]=0;
	  printf("   - downloading file %s",b);
	  chdir(makeDirs(b));
	fd=fopen(b,"wb"); // ARRGGHHH! odio a WINDOWS!!!
	if (!fd) 
	{
		printf("[e] Cannot open file for writing ?!? \n");
		exit(1);
	}
	  recv(s,b,4,0); // get file size
	  i=(unsigned int *)b;
	  j=ntohl(*i);
	  printf("    Size of it is: %d\n",j);
	  printf("Bsize: %d\n",bsize);
	  
	  for(	I=n=0; 
		I<j;  
		I+=(I+bsize>j)?j-I:bsize,n++
	     )
	  {
		recv(s,b,(I+bsize>j)?j-I:bsize,0);
		fwrite(b,(I+bsize>j)?j-I:bsize,1,fd);
	  }
	  
	  printf("    Recived %d bytes\n",j);
	fclose(fd);
	chdir("../..");
	free(b);
}

void cli_reciveMove()
{
	char pkt[16];
	char who;
	char rot,ani,i;
	float *x,*y,*z;
	char v[4];

//	memset(pkt,0,15); // fucking null.
	recv(s,pkt,15,0);

	x=(float *)(pkt+1);
	y=(float *)(pkt+5);
	z=(float *)(pkt+9);
	
	who=pkt[0];
	rot=pkt[13];rot*=2;
	ani=pkt[14];
}

void cli_reciveJoin()
{
	char pkt[3],*b;
	char who;
	char rot,ani,i;
	float *x,*y,*z;
	char v[4];
	printf("RECIVE JOIN\n");

	memset(pkt,0,15); // fucking null.
	recv(s,pkt,2,0);
	
	who=pkt[0];
	b=(char *)malloc(pkt[1]+1);
	memset(b,0,pkt[1]+1);
	recv(s,b,pkt[1],0); // Get Nick
	printf("Nick is: %d %s\n",who,b);

	recv(s,pkt,1,0);
	b=(char *)realloc(b,pkt[0]+1);
	memset(b,0,pkt[0]+1);
	recv(s,b,pkt[0],0);
	printf("RPH is: %s\n",b);
	
	return;
}


void cli_reciveVers()
{
	char b[2];
	char *str;
	recv(s,b,2,0);
	str=(char *)malloc(b[1]+1);
	recv(s,str,b[1],0);
	str[b[1]]=0;
	printf("Version: %d (banner: %s)\n",b[0],str);
	free(str);
}

void cli_reciveKey()
{
	printf("Reciving PACKET KEY\n");
	recv(s,key,4,0);
	printf("Key recived: [%2x:%2x:%2x:%2x]\n",
			(unsigned char)key[0],
			(unsigned char)key[1],
			(unsigned char)key[2],
			(unsigned char)key[3]);
}

void cli_reciveWeapon()
{
	char b[3];
	recv(s,b,3,0);
	printf("Change User %d weapon to %d, munition %d\n",b[0],b[1],b[2]);
}

void cli_reciveTalk()
{
	char b[2],*str;
	recv(s,b,2,0);
	str=(char *)malloc(b[1]+1);
	recv(s,str,b[1],0);
	str[b[1]]=0;
	printf("TALK: %d %s (%d)\n",b[0],str,b[1]);
	free(str);
}

void cli_recivePart()
{
	char b[1];
	recv(s,b,1,0);
	printf("Player %d parts the game.\n",b[0]);
}

void cli_reciveBegin()
{
	float x,y,z,r;
	char hab,i,me;
	char b[17];
	recv(s,b,17,0);

	printf("Begin recived, game must begin!\n");
	printf("%f %f %f \n",b+1,b+5,b+9);

	memcpy(&x,b,4);
	memcpy(&y,b+4,4);
	memcpy(&z,b+8,4);
	memcpy(&r,b+12,4);
	memcpy(&hab,b+16,1);
	printf("YOU ARE %d HERE: %f %f %f r:%f h:%d\n",me, x,y,z,r,hab);
}



