#ifndef _CLIENT_H_
#define _CLIENT_H_

#include "universe.h"

#include "../common/status.h"
#include "../common/packet.h"
#include "main.h"
#include <sys/types.h>

extern Client client;
extern ServerConf cfg;
extern char *getDirs(char *str);

void *clientWorker(void *arg);
int analizePackage(int me, char buf);
int nickIsUsed(int me,char *b);
int checkBounding(float x1,float y1,float z1,float x2,float y2,float z2);
FILE *glh_fopen(char *f,char *m);
void glh_fclose(FILE *fd);
void glh_srand();

void glh_closeConnection(int me, char *str);
void glh_sendServerVersion(int me);
void glh_sendBeginPoint(int,int);
void glh_sendRoleData(int me);
void glh_userDead(int me);
void glh_readUser(int me);
void glh_readPass(int me);
void glh_readTalk(int me);
void glh_readNick(int me);
void glh_readCrcf(int me);
void glh_readMove(int me);
void glh_readWeap(int me);
void glh_readChwp(int me);
void glh_readOkOk(int me);
void glh_readShot(int me);
void glh_broadcast(int me, char *b, int l);

void loadRoleData(int me, char *f);
void loadCarData(int me);

#endif

