#ifndef _GAME_H_
#define _GAME_H_

#include "OpenGLH.h"
#include "Collision.h"
#include "Stage.h"
#include "Render.h"
#include "Controls.h"
#include "Networkh.h"
#include "Dirs.h"

#define UPDATE_DELAY 30

//The main class of the game. It Propertiess all input and output events and has all the info inside
class Game
{
private:
	Stage *stg;		//This will Properties the information of the stage
 	Render *renderScreen;	//This will render everything
	Networkh *net;		//Controls the sockets connection
	Collision *col;		//Collisions...let's go!
	unsigned int updateTime;
	unsigned int updateDelay;
	unsigned int loading;
	bool inGame;
	Uint32 ticks,msgticks; // for trace route
	void updateNet();

public:
	Controls *ctr;		// mouse and keyboard

	Game(char *,char *);
	~Game();
	
	void draw();
	
	void input();
};

#endif

