#ifndef _MATERIAL_H_
#define _MATERIAL_H_

#include "OpenGLH.h"
#include <string.h>

class Material
{
private:
	float amb[4]; /* GL_AMBIENT */
	float dif[4]; /* GL_DIFFUSE */
	float spe[4]; /* GL_SPECULAR */
	float emi[4]; /* GL_EMISSION */
	float shi;    /* GL_SHININESS */

public:
	Material();

	void setProperty(int,float *);
	void setProperty(int,float);

	void draw();
};

#endif
