#ifndef _SKY_H_
#define _SKY_H_

#include "TGAloader.h"
#include "OpenGLH.h"

enum {
	BACK_ID=0,
	FRONT_ID,
	BOTTOM_ID,
	TOP_ID,
	LEFT_ID,
	RIGHT_ID
};

class Sky
{
	private:
	Uint32 nextChange;
	GL3f night;
	void init();
	bool loaded;

	public:
	float x,y,z;
	float width,height,length;
	unsigned int tex[6];
	Sky();
	~Sky();
	void draw(GL3f pos);
	Sky(float x, float y, float z, float width, float height, float length);
	void setDimension(float x, float y, float z, float width, float height, float length);
	bool loadSky(char *ruta);
};


#endif


