#ifndef _TGALOAD_H_
#define _TGALOAD_H_

#ifdef WIN32
#include <windows.h>
#endif

#include "../../config.h"
#if HAVE_SDL_IMAGE
#include <SDL/SDL_image.h>
#endif

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "OpenGLH.h"
#include "Dirs.h"


#define TGAHEAD 12
#define TGASIZE 12
#define TGAMAP24 18
#define TGAMAP32 17 // 17
#define TGAMAP16 18

// Define or undefine this define :D
//#define BZIP2
#ifdef BZIP2
#include <bzlib.h>
#endif

unsigned char *TGAloader(char *t, int *w, int *h, int *bpp);
unsigned int TGAloader_tid(char *);
unsigned int TGAloader_tid(char *,int *);
void TGAloader_untid(unsigned int tid);

#endif
