#ifndef _TRACES_H_
#define _TRACES_H_

#include <stdio.h>
#include "OpenGLH.h"

#define DEGREE 3

class Traces
{
	private:
	int n; // number of control points
	int i; // number of control points attached to the trace
	float *u;
	float *cp; // control points
	float pos;
	bool init;
	void doInit();
	GL3f* line;
	int line_limit;
	float SplineBlend(int k ,int t,float v);

	public:
	Traces(int n);
	~Traces();
	void draw();
	void addControlPoint(float x, float y, float z);
	GL3f getObjectiveVector(GL3f xyz);
	GL3f getPosition(float v);
	GL3f getNextPosition();
};

#endif
