#include "main.h"

Fl_Progress *p;
ScriptH *scr;
Fl_Window *w;
Fl_Box *b;
Fl_Box *i; //image

static Fl_PNG_Image *img;//("glh.png");

int main(int argc, char *argv[])
{
	try {
		scr=new ScriptH(DEFAULT_SCRIPT);
	} catch (Error *err) {
		printf("Error %s\n",err->getMessage());
		return (1);
	}
		
	w=new Fl_Window(350,330,"glHi");
	i = new Fl_Box(45,10,260,100);
	img=new Fl_PNG_Image("glh.png");
	b = new Fl_Box(20,130,310,140);
		b->box(FL_PLASTIC_DOWN_BOX);
	p = new Fl_Progress(20,280,310,25);
		p->box(FL_PLASTIC_DOWN_BOX);
		p->color(255,100);
		p->maximum(100);
		p->value(0);

	w->end();
	p->show();
	i->show();
	w->show(argc,argv);

	scr->setProgress(p);
	scr->setBox(b);
	scr->setImageBox(i);

	do Fl::wait(.01); while(scr->Run());

	scr->Done();

	return Fl::run();
}


