#include "main.hh"
#include "glhimg.h"

void createButton(int y, char *label,Fl_Callback* cb)
{
	Fl_Button *o=new Fl_Button(5,y,300,25,label);
	o->down_box(FL_PLASTIC_DOWN_BOX);
	o->box(FL_PLASTIC_UP_BOX);
	o->callback(cb);
}

const char *checkString(const char *str)
{
        int i=0;
        while(str[i++])
		if (str[i]!=' ') return str;
        return "null";
}       

const char* checkInput(char *str)
{
        if (!strcmp("null",str)) return "";
        else return str;
}


int main(int argc, char **argv) {
  Fl_Window *window = new Fl_Window(310,340,"glH mainmenu");
  Fl_Box *box = new Fl_Box(5,9,300,100);
  box->image(image_glh);
  createButton(129,"&Start game",(Fl_Callback*)play);
  createButton(159,"&Keyboard configuration",(Fl_Callback*)keyb);
  createButton(189,"&Video options",(Fl_Callback*)video);
  createButton(219,"&Audio options",(Fl_Callback*)sound);
  createButton(249,"&Documentation",(Fl_Callback*)docu);
  createButton(279,"About &Us",(Fl_Callback*)about);
  createButton(309,"&Quit",(Fl_Callback*)quit);
  window->end();
  window->show(argc, argv);
  return Fl::run();
}
