#include "dirs.h"

FILE *glh_fopen(char *str,char *m)
{
	FILE *fd;
	makeDirs(str);
        chdir(getDirs(str));
        fd=fopen(str,m);
	chdir("../..");
	return fd;
}

void glh_fclose(FILE *fd)
{
        fclose(fd);
        //chdir("../..");
}


char * getDirs(char *str)
{
	#define N 12
	int i=N;

	typedef struct 
	{
	char *ext;
	char *dir;
	} DirNames; 

	DirNames dn[N]=
	{ 
           {"mph","data/maps"},
           {"mdh","data/modl"},
           {"tg2","data/text"},
	   {"tga","data/text"},
           {"rph","data/role"},
	   {"ith","data/item"},
	   {"wph","data/weap"},
	   {"pvs","data/maps"},
	   {"auh","data/maps"},
	   {"car","data/cars"},
	   {"wav","data/soun"},
	   {"ogg","data/soun"}
        };

	while (i--)
	{
	if ( !strcmp(dn[i].ext,str+strlen(str)-3) )
		{
		return dn[i].dir;
		}
	}
	return "data/unkn";
}

char * makeDirs(char *str)
{
	char *dir;
	
	mkdir ("data",0700); // oktal f0r /-rwx --- ---/
	dir=getDirs(str);
	mkdir(dir,0700);
	return dir;
}
