#ifndef _INCLUDE_DIRS_H_
#define _INCLUDE_DIRS_H_

#include "../common/platform.h"

#if WINDOWS
   #include <direct.h>
   #define mkdir(str,str2) mkdir(str)
#else
   #include <unistd.h>
   #include <sys/stat.h>
   #include <sys/types.h>
#endif
   #include <stdio.h>
   #include <string.h>
   



char * makeDirs(char *str); // make directories needed for this filename
char * getDirs(char *str);  // return the directory name for this kind of file.
FILE * glh_fopen(char *str,char *m);
void   glh_fclose(FILE *fd);

#endif
