#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "../common/dirs.h"
#include <sys/socket.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <signal.h>
#include <netdb.h>

class Database {
private:
	int port,
	    sock; /* aka mitjo */
	char *svr;
	
private: // methods 
	int sendData(char *string);
	long recvData(char *string,long size);
	int readline(char *string,int size);
	int getFile (char *string);
	int getDeps (char *string);
	int DBconnect();
	int DBdisconnect();
public:
	/* Ctors and Dtors */
	Database(const char *svr, int port=80);
	~Database();
	/* Methods */
	void setServer(const char *svr, int port=80);
	const char *getServer();
	int getPort();
	/* Auth */
	long authUser(char *user, char *pwd, char *key);
	int deauthUser(char *nick, long ID);
	int sendKeepAlive(char *nick, long ID);
};
