#include "client.h" 
extern void glh_itemCollision(int me);

void checkPosition(int me,float x,float y, float z, int rot, int ani)
{
	
	int i = 0;
#if COLLISION
    cols::CColInfo infoCol;
	y-=9.8*cfg.ratio;
    ODvector3 vIncPos (x-client.p[me].x, y-client.p[me].y, z-client.p[me].z );

	do {
        // Detecta la primera collisi
			infoCol = cfg.pUnivers->DetectCollision( 0, me, vIncPos );

        // Mou l'entitat la distncia lliure de collisions
			client.p[me].x+=infoCol.vFree.x;
			client.p[me].y+=infoCol.vFree.y;
			client.p[me].z+=infoCol.vFree.z;
			cfg.pUnivers->MoveEntity( 0, me, infoCol.vFree );

        // Si s'ha produt collisi cal respondre
        	if ( infoCol.bCol ) 
		{
	            ODvector3 vNormPlaLlisc = infoCol.planeCol.Normal();
	            ODreal  nDist = vNormPlaLlisc * infoCol.vRemainder;
	            ODvector3 vLlisc = infoCol.vRemainder - vNormPlaLlisc * nDist;
	            vIncPos = vLlisc;
	        }
	} while ( infoCol.bCol && ++i < 4 );
#endif
	
	// Portal collisions ( @Legs level ) 
	//checkPortalCollision(me,vm);
	

	// Position Ok, save it :)

	client.p[me].rot=rot;
	client.p[me].ani=ani;

	if (cfg.v>2)
	printf("%d move to %f %f %f rot:%d ani:%d\n",
		me, client.p[me].x,client.p[me].y,client.p[me].z,
		rot,ani);
}

void glh_readMove(int me)
{
	char pkt[20]; // (packet is 11, 2more for header)
	int s=client.p[me].sock;
	float *x,*y,*z;

	recv(s,pkt+2,14,0);
	pkt[0]=PACKET_MOVE;
	pkt[1]=(char)me;
	
	// we must get xyz and check it.
	x=(float *)(pkt+2);
	y=(float *)(pkt+6);
	z=(float *)(pkt+10);

	client.p[me].x=*x;
	client.p[me].y=*y;
	client.p[me].z=*z;


	checkPosition(me, *x,*y,*z,(int)pkt[14],(int)pkt[15]);

	// check item collision
	glh_itemCollision(me);
		
	// send a broadcast message of this new position
	glh_broadcast(-1,pkt,16);
	//send(client.p[me].sock,pkt,16,0);
}


