#include "../common/crc32.h"
#include "chkpwd.h"
	

int 
getParm(char *ptr,char *str)
{
	int i,j,n,len;
	len=strlen(str);
	for(n=j=0,i=1;i<len;i++) {
		if (str[i]==',') {
			str[i]=0;
			ptr[n++]=atoi(str+j);
			j=i+1; }}
	ptr[n]=atoi(str+j);
	if ((n!=3)||(!strlen(str+j)))
	{
		return 0;
	}
	return 1;
}

int checkPwd(char *passw,char *pwd, char *key)
{
	unsigned int pwdlen=strlen(pwd),
	             crc,*c,i,j;
	for(i=0;i<4;i++) for(j=0;j<pwdlen;j++)
		passw[j]^=key[i];
	crc=crc32(passw,pwdlen);
	c=(unsigned int *)pwd;
	if (crc!=*c)
		return 0;
	else	return 1;
}

int
main(int argc, char *argv[])
{
	char pwd[4],
	     key[4],
	    *passwd;
	if (argc!=4)
	{
		printf("Usage: %s [password] pwd[d,d,d,d] key[d,d,d,d]\n",
			argv[0]);
		return 1;
	}
	
	passwd=argv[1];

	if (
	getParm(pwd,argv[2]) ||
	getParm(key,argv[3]) ) 
	{ printf("ER"); return 1; }

	printf("%s",checkPwd(argv[1],pwd,key)?"OK":"ER");
	
	return 0;
}



